; WERNER --- Das Spiel
; ====================

; (C) 1987 by Karl H. Schfer
;             Mlhauser Strae 2
;             7813 Staufen i. Br.
;             Tel.: (07633) 7461
; (C) 1989 by Harald Gieleen
;             An den Abtshfen 13
;             3392 Clausthal-Zellerfeld

        section       prog

        bra.s         game
        nop
        nop
        dc.w          $4afb
        dc.w          6
        dc.b          'WERNER'
game    sub.l         d1,d1         ;4 farben
        move.b        d1,d2         ;monitor
        move.b        #$10,d0       ;displaymodustrap
        lea           98403,a0      ; fr Screen-Abschalten
        move.b        #2,(a0)       ;screen-off
        trap          #1            ; MODE 4
        bsr           menusetup     ;initialisierungen
        bra.s         cont
menu    bsr           nexttime      ;startbild ausgeben
cont    lea           score(pc),a0  ;score = d0 = 0
        move.l        d0,(a0)       ;setzen
mlb     move.w        #$8f,d2       ;schleife zur tastaturabfrage
ofter   lea           fkeys(pc),a3  ;befehlsparameter fuer IPC
        move.b        #$11,d0       ;tastaturreihe 0 fuer
        trap          #1            ; F1,F2 abfragen
        move.b        d1,d7         ;wenn F2 gedrckt
        and.b         #8,d7         ;wurde
        bne.s         anleit        ;anleitung ausgeben
        move.b        d1,d7         ;wenn F1 gedrckt
        and.b         #2,d7         ;wurde
        bne           firstlev      ;dann spielstart
        lea           return,a3
        moveq         #$11,d0
        trap          #1            ;kill job, if ESC was hit
        andi.b        #8,d1
        bne           kill_me
        dbra          d2,ofter      ;schleifenende
        lea           scrollid(pc),a1 ; (C)-Window recol
        move.l        (a1),a0
        lea           farbliste(pc),a1
        move.b        #$26,d0
        move.w        #-1,d3
        trap          #3
        bra.s         mlb
return  dc.b          9,1,0,0,0,0,1,2
fkeys   dc.b          9,1,0,0,0,0,0,2
farbliste
        dc.b          2,2,4,4,6,6,0,0
anldef  dc.w          15
        dc.b          'SCR_512X256A0X0'
anlid   dc.w          0,0
anleit  bsr           sound         ;startsound
        lea           98403,a0      ;bild
        move.b        #2,(a0)       ;aus
        move.l        anlid(pc),a0  ; Screen vorbereiten
        move.w        #-1,d3        ;warte bis fertig
        move.w        #4,d2         ;borderbreite
        move.b        #2,d1         ;borderfarbe
        move.b        #$c,d0        ;border
        trap          #3            ;setzen
        move.w        #3,d1         ;maximale
        move.w        #1,d2         ;zeichen-
        move.b        #$2d,d0       ;gre
        trap          #3            ;setzen
        move.b        #$20,d0       ;fenster
        trap          #3            ;lschen
        move.w        #uberend-uberstart,d2   ;textlnge
        lea           uberstart(pc),a1        ;textanfang
        move.b        #7,d0         ;laden und
        trap          #3            ; Text ausgeben
        move.w        #2,d1         ;zeichengre ist
        sub.w         d2,d2         ;doppelte breite
        move.b        #$2d,d0       ;und einfache
        trap          #3            ;hhe
        move.w        #restend-reststart,d2   ;lnge anleitungstext
        lea           reststart(pc),a1        ;anleitungstext anfang
        move.b        #7,d0         ;text
        trap          #3            ;ausgeben
        move.b        #1,d5         ;sprite nummer 1
        move.b        #2,d7         ;aus diesen daten wird der
        move.b        #2,d6         ;spriteanfang erzeugt
        bsr           showsprite    ;sprite darstellen
        move.b        #7,d5         ;sprite nummer 7
        move.b        #16,d7        ;diese
        move.b        #3,d6         ;vier
        bsr           showsprite    ;sprites
        move.b        #9,d5         ;sprite nummer 9
        move.b        #18,d7        ;werden
        move.b        #3,d6         ;im
        bsr           showsprite    ;anleitungstext
        move.b        #4,d5         ;sprite nummer 4
        move.b        #17,d7        ;dargestellt
        move.b        #7,d6
        bsr           showsprite
        lea           98403,a1      ;bild
        move.b        #0,(a1)       ;ein
spacebar
        lea           return(pc),a3 ;IPC befehl
        move.b        #$11,d0       ;tastaturreihe abfragen
        trap          #1            ; Leertaste abfragen
        and.b         #64,d1        ;gedrckt ?
        beq.s         spacebar      ;wenn nicht dann nochmal abfragen, sonst
        bsr           sound         ;anleitung beenden, piepsen und
        bra           menu          ;startbild ausgeben
firstlev
        lea           scrollid(pc),a1  ;im copyrightwindow soll der level
        move.l        (a1),a0
        move.w        #-1,d3        ;eingegeben werden
        move.b        #$20,d0
        trap          #3            ;cls
        move.w        #firend-firstart,d2   ;textlnge
        lea           firstart,a1
        move.b        #7,d0
        trap          #3            ;text senden
        move.w        #4,d2         ;startlevel max. 3-stellig
        lea           premium,a1    ;da kommt der startlevel hin
        move.l        #0,(a1)       ;clear buffer
        move.b        #2,d0         ;holt die Eingabe
        clr.l         d4
        trap          #3            ;nach premium
        subq.l        #1,a1         ;zeiger auf letztes byte (Enter) der eingabe
        subq.b        #2,d1         ;zahl der geholten bytes korrigieren
        move.b        d1,d4         ;d4 ist schleifenzhler
        clr.l         d5            ;z. rechnen freimachen
        move.l        #1,d3         ;reg. f. zehnerpotenz
checking
        move.b        -(a1),d6      ;eine stelle holen
        cmpi.b        #$30,d6       ;falls ascii v. eingabe <48
        bmi.s         firstlev      ;then neueingabe
        cmpi.b        #$3a,d6       ;falls ascii v. eingabe>57
        bge.s         firstlev      ;then neueingabe
        sub.b         #$30,d6       ;ascii-code auf zahl korrigieren
        mulu          d3,d6         ;wert der stelle
        add.b         d6,d5         ;und aufsummieren
        mulu          #10,d3        ;nchste stelle
        dbra          d4,checking   ;nchste stelle abarbeiten
        sub.b         #1,d5         ;korrigieren
        tst.b         d5            ;if null eingegeben
        bmi.s         firstlev      ;then neueingabe
        lea           maxlev,a1     ;testen ob
        move.b        (a1),d4
        cmp.b         d5,d4         ;levelnr nicht
        bmi.s         firstlev      ;zu hoch
        lea           erstlev,a1    ;startlevel
        move.b        d5,(a1)       ;schreiben
        bra           spielstart    ;ab geht's

hinher  lea           werner_x(pc),a0 ;startposition werner
        move.b        (a0)+,d7      ;x und y der
        move.b        (a0),d6       :startposition
        bsr           showsprite
        move.w        #$fff0,d7     ;warteschleife
warten  dbra          d7,warten
        rts

menusetup
        lea           98403,a0      ; Ausgabe des Hauptmenscreen
        moveq         #-1,d1
        move.b        #2,(a0)       ;off
        lea           kanal1(pc),a0 ;daten f. ausgabefenster
        move.l        #2,d3
        move.b        #1,d0         ;oeffne-kanal-trap
        trap          #2            ; Definieren der Windows
        lea           k1id(pc),a5   ;id von kanal1
        move.l        a0,(a5)       ;nach k1id
        lea           anldef(pc),a0 ;daten fullscreen window
        move.b        #1,d0         ;window
        trap          #2            ;setzen
        lea           k2id(pc),a5   ;id des zweiten windows
        move.l        a0,(a5)       ;nach k2id
        lea           scrollscr(pc),a0        ;das copyrightfenster
        move.b        #1,d0         ;wird geoeffnet
        trap          #2            ;und die
        lea           scrollid(pc),a5         ;zugehoerige kanalid
        move.l        a0,(a5)       ;wird abgespeichert
        lea           anldef(pc),a0 ;noch ein
        move.b        #1,d0         ;fullscreen
        trap          #2            ;window
        move.w        #-1,d3        ;warte bis fertig
        move.b        #226,d1       ;farbwert fuer das letzte window
        move.b        #$27,d0       ;setze papierfarbe
        trap          #3            ; Farben setzen
        move.b        #$28,d0       ;strip fuer
        trap          #3            ;das fenster
        sub.b         d1,d1         ;ink
        move.b        #$29,d0       ;wird null
        trap          #3            ;gesetzt
        lea           anlid(pc),a5  ;id des 2. fullscreen
        move.l        a0,(a5)       ;fensters speichern
        move.l        scrollid(pc),a0         ;id laden
        move.w        #-1,d3        ;warte bis fertig
        move.b        #7,d1         ;farbwert
        move.b        #$27,d0       ;paperfarbe
        trap          #3            ;setzen
        move.b        #$28,d0       ;strip bekommt
        trap          #3            ;dieselbe farbe
        sub.b         d1,d1         ;ink
        move.b        #$29,d0       ;wird
        trap          #3            ;null
        move.w        #2,d1         ;charactergroee und -breite
        sub.w         d2,d2         ;auf 5 mal 9
        move.b        #$2d,d0       ;mit raum 8 mal 10
        trap          #3            ;setzen
nexttime
        lea           98403,a0      ;screen
        move.b        #2,(a0)       ;off
        move.l        k2id(pc),a0   ;window id laden
        move.w        #3,d1         ;groete
        move.w        #1,d2         ;zeichen-
        move.w        #-1,d3        ;groee
        move.b        #$2d,d0       ;ein-
        trap          #3            ;stellen
        move.b        #$20,d0       ;ganzes fenster
        trap          #3            ;loeschen
        move.w        #menuend-menustart,d2 ;zahl der zu sendenden bytes
        lea           menustart(pc),a1        ;stringanfang
        move.b        #7,d0         ;string
        trap          #3            ;senden
        move.l        scrollid(pc),a0         ;window id laden
        move.b        #2,d1         ;borderfarbe
        move.w        #3,d2         ;borderbreite
        move.b        #$c,d0        ;border
        trap          #3            ;setzen
        move.b        #$20,d0       ;fenster
        trap          #3            ;loeschen
        move.w        #copyend-copystart,d2   ;lnge copyright
        lea           copystart(pc),a1        ;anfang copyright
        move.b        #7,d0         ;copyright
        trap          #3            ;ausgeben
        lea           $20880,a0     ; Werner-Schriftzug ausgeben
        lea           hiresbild(pc),a1        ;an dieser adresse steht 8704
        move.b        #31,d4
        move.w        #135,d0
bildi   move.w        #63,d1        ;uere schleife 136 mal
zeili   move.b        (a1)+,d2      ;innere schleife 64 mal
        move.b        d2,d3         ;hier wird der
        and.b         d4,d2         ;WERNER-schriftzug ausgegeben
        move.b        d2,(a0)+      ;die daten stehen nach hiresbild
        move.b        d3,(a0)+      ;und sind nicht in
        dbra          d1,zeili      :diesem listing enthalten
        rol.b         #1,d4         ;schrgstreifen im schriftzug
        dbra          d0,bildi
        lea           98403,a0      ;bild
        sub.l         d0,d0         ;wieder
        move.b        d0,(a0)       ;einschalten
        rts

spielstart
        bsr           sound         ;pieps
        lea           98403,a0      ;bild
        move.b        #2,(a0)       ;aus
        lea           $20000,a0     ;bildanfang laden
        lea           $20080,a1     ;anfang 2. bildzeile laden
        move.w        #127,d0       ;schleife 128 mal
cls0    move.w        #31,d1        ;schleife 32 mal
cls1    move.l        #2857740885,(a0)+       ;pixelmuster mit dem der
        move.l        #1437226410,(a1)+       ;screen gefllt wird
        dbra          d1,cls1
        move.l        a1,a0         ;2 zeilen weiter
        add.l         #128,a1
        dbra          d0,cls0
        move.l        k1id(pc),a0   ;kanalnr laden
        move.b        #7,d1         ;borderfarbe
        move.w        #3,d2         ;borderbreite
        move.w        #-1,d3        ;warte bis fertig
        move.b        #$c,d0        ;border
        trap          #3            ;setzen
        move.b        #$20,d0       ;fenster
        trap          #3            ;lschen
        move.w        #titlend-titlest,d2     ;lnge statuszeile
        lea           titlest(pc),a1          ;anfang statuszeile
        move.b        #7,d0
        trap          #3            ; Statuszeile ausgeben (Lives etc.)
        lea           lives(pc),a0  ;zum anfang
        move.b        #6,(a0)       ;gibt es 6 leben
        lea           level(pc),a0  ;startlevel ist
        lea           erstlev,a1    ;der
        move.b        (a1),(a0)     ;eingegebene
auf     lea           bonus(pc),a0  ;bonus
        move.l        #$10000,(a0)  ;ist 10000
        bsr           showhiscore   ;highscore ausgeben
        bsr           showbonus     ;anfangsbonus ausgeben
        lea           98403,a0      ;bild
        move.b        #0,(a0)       ;an
        bsr           aufbauen      ; Level schrg aufblttern
        move.w        #3,d0         ;werner blinkt 4 mal
change  move.b        #0,d5         ;sprite nr 0 - leersprite
        bsr           hinher        ;sprite darstellen
        lea           which_werner(pc),a0     ;wernersprite
        move.b        (a0),d5       ;raussuchen
        bsr           hinher        ;und darstellen
        dbra          d0,change     ;ende nach 4. mal
        lea           counter(pc),a0;zhler
        sub.l         d0,d0         ;wird
        move.b        d0,(a0)       ;gelscht
        lea           level(pc),a0  ;zahl der
        move.b        (a0),d0       ;bierflaschen
        lea           bieranz(pc),a0;fr dieses
        add.l         d0,a0         ;level laden und
        lea           numbier(pc),a1;nach
        move.b        (a0),(a1)     ;numbier schreiben
haupt   bsr           animation     ; Hauptroutine!!!
        bsr           tastatur
        bsr           bullen
        bsr           steine
        bsr           dobonus
        bra.s         haupt

lostlife
        bsr           findschl      ; Routine fr verlorenes Live
        lea           lives(pc),a0
        move.b        (a0),d0
        sub.b         #1,d0
        beq.s         endofgame
        move.b        d0,(a0)
        bsr           showlives
        move.w        #3,d0
tots    move.w        d0,-(a7)
        move.b        #8,d5
        bsr           insert
        move.w        (a7)+,d0
        dbra          d0,tots
        bra           auf
endofgame
        move.w        #5,d0
death   move.w        d0,-(a7)      ; Todeskreuz blinken lassen
        move.b        #8,d5
        bsr           insert
        move.b        #10,d5
        bsr           insert
        move.b        #10,d5
        bsr           insert
        move.w        (a7)+,d0
        dbra          d0,death
abortgame
        lea           score(pc),a0
        move.l        (a0)+,d0
        move.l        (a0),d1
        cmp.l         d0,d1
        bgt.s         go_on
        move.l        d0,(a0)
go_on   bra           menu

showscore
        lea           score(pc),a2  ; BCD-Werte ausgeben
        move.w        #9,d1
        bra.s         show
showhiscore
        lea           hiscore(pc),a2;adresse des highscore laden
        move.w        #33,d1        ;cursorposition
        bra.s         show          ;werte anzeigen
showbonus
        lea           bonus(pc),a2  ;adresse des bonus laden
        move.w        #55,d1        ;cursorpositon
show    move.w        #-1,d3        ;warte bis fertig
        lea           k1id(pc),a0   ;kanalid statusfenster
        move.l        (a0),a0       ;laden
        move.b        #$11,d0       ;cursor
        trap          #3            ;setzen
        move.l        (a2),d7       ;highscore, score oder bonus laden
        move.l        d7,d4         ;den wert nach d4
        swap          d4            ;registerhlften tauschen
        bsr           word
        move.w        d7,d4
word    move.w        d4,d5         ;zweites wort des wertes nach d5
        lsr.w         #8,d5         ;und durch 256 teilen
        bsr           byte
        move.b        d4,d5
byte    move.b        d5,d1         ;oberstes byte des wertes nach d1
        lsr.b         #4,d1         ;durch 16 teilen, das ergibt das
        bsr           nibble        ;oberste nibble des wertes
        move.b        d5,d1
nibble  and.b         #15,d1        ;
        add.b         #48,d1        ;d1+48, wegen ASCII
        move.b        #5,d0         ;byte
        trap          #3            ;senden
        rts                         ;bis der score abgearbeitet ist


showlives
        lea           k1id(pc),a0   ; ein X fr jedes Leben
        move.l        (a0),a0
        move.w        #-1,d3
        move.w        #76,d1
        move.b        #$11,d0
        trap          #3
        move.w        #5,d2
        lea           leerstart(pc),a1
        move.b        #7,d0
        trap          #3
        move.w        #76,d1
        move.b        #$11,d0
        trap          #3
        lea           lives(pc),a2
        move.b        (a2),d2
        and.w         #255,d2
        cmp.b         #1,d2
        beq.s         no_ix
        sub.b         #2,d2
moreix  move.b        #5,d0
        move.b        #88,d1
        trap          #3
        dbra          d2,moreix
no_ix   rts

levelcompl
        bsr           findschl      ; Routine fr geschafften Level
        lea           bonus(pc),a0  ; Bonus dem Score aufaddieren
        cmp.l         #$100,(a0)
        blt.s         aufhoren
        move.l        #$99999900,d7
        bsr           bcderh
        lea           score(pc),a0
        move.l        #$100,d7
        bsr           bcderh
        bsr           showscore
        bsr           showbonus
        bra.s         levelcompl
aufhoren
        lea           score(pc),a0
        move.l        8(a0),d7
        move.l        #0,8(a0)
        bsr           bcderh
        bsr           showscore
        bsr           showbonus
        lea           level(pc),a0  ;aktuelle levelnr
        add.b         #1,(a0)       ;eins drauf
        lea           maxlev,a2     ;hchste levelnr-1 laden
        move.b        (a2),d1
        addq.b        #1,d1         ;korrigieren
        cmp.b         (a0),d1
        bne.s         gump          ;nchster level
        move.b        #0,(a0)       ;oder von vorne
gump    bra           auf

aufbauen
        lea           level(pc),a0  ;levelnummer
        move.b        (a0),d0       ;laden
        and.w         #255,d0       ;mal 296, da ein level aus
        mulu          #296,d0       ;296 sprites aufgebaut wird
        lea           leveldata(pc),a0        ;startadresse leveldaten daten
        add.l         d0,a0         ;leveldaten raussuchen
        lea           werner_x(pc),a1         ;adresse der x-position laden
        move.w        #8,d0         ;8. wort der leveldaten
ldir    move.l        (a0)+,(a1)+   ;enthlt
        dbra          d0,ldir       ;erste spritenummer
        move.l        a0,a4         ;aktuellen zeiger auf leveldaten laden
        move.w        #64,d0        ;64 mal
lddr    move.l        (a4)+,(a1)+   ;word der leveldaten
        dbra          d0,lddr       ;kopieren
        move.w        #0,d0
sup     move.w        #0,d1         ;eigentlicher schleifenbeginn
        move.w        d0,d2         ;dies
shoch   cmp.w         #19,d2        ;ist
        bgt.s         donot         ;die
        move.w        d1,d6         ;routine
        move.w        d2,d7         ;fr
        mulu          #20,d6        ;das
        add.w         d7,d6         ;schrge
        move.l        a0,a1         ;aufblttern
        add.l         d6,a1
        move.b        (a1),d5       ;spritenummer
        move.w        d1,d6
        bsr           showsprite
donot   add.w         #1,d1
        cmp.w         #13,d1
        beq.s         sexit
        sub.w         #1,d2
        bcc.s         shoch
sexit   move.w        #$1000,d7     ; Warten nach einer Schrgzeile
swart   dbra          d7,swart      ;4096 zyklen warten
        add.w         #1,d0         ;nchste schrgzeile
        cmp.w         #33,d0        ;ende nach 33 schrgzeilen
        bne.s         sup
        rts

bcderh  lea           operator(pc),a1 ; BCD-Longword-Addierer
        move.l        d7,(a1)+
        add.l         #4,a0
        sub.l         d7,d7
        abcd          -(a1),-(a0)
        abcd          -(a1),-(a0)
        abcd          -(a1),-(a0)
        abcd          -(a1),-(a0)
        rts
operator
        dc.w          0,0

; Die Spriteroutine!!!
showsprite
        and.w         #127,d5       ;hier werden die ersten worte
        and.w         #127,d6       ;der register mit spriteverwaltungsdaten
        and.w         #127,d7       ;geladen
        mulu          #108,d5       ;startadresse des richtigen sprites erz.
        lea           spritedata(pc),a4       ;adresse der spritedaten
        add.l         d5,a4         ;daten des richtigen sprites herausssuchen
        mulu          #18*128,d6    ;18*128 ist die lnge einer spritezeile
        add.l         #4,d6         ;korrektur
        lea           $20980,a5     ;anfang spielfeld
        add.l         d6,a5         ;spriteanfang
        mulu          #6,d7         ;spriteanfang in der zeile
        add.l         d7,a5         ;hier wird sprite hingemalt
        move.w        #17,d5        ;18 spritezeilen
sloop   move.l        (a4)+,(a5)+   ;erste 16 pixel einer spritezeile darst.
        move.w        (a4)+,(a5)    ;letzte 8 pixel einer spritezeile darst.
        add.l         #124,a5       ;anfang nchste spritezeile
        dbra          d5,sloop
        rts

; Steuerroutine fr die Wernerfigur
tastatur
        lea           werner_x(pc),a0
        move.b        (a0)+,d3
        move.b        (a0),d4
        bsr           calc
        move.l        a0,a2
        cmp.b         #1,d0         ; Test ob noch existent
        beq.s         alive
        cmp.b         #2,d0
        beq.s         alive
        move.b        #1,(a0)
        bra           lostlife      ; ansonsten: tot
alive   lea           return(pc),a3
        move.b        #$11,d0
        trap          #1            ; Tastatur/Joystick abfragen
        move.b        d1,d0
        and.b         #222,d0
        bne.s         warwas
        rts
warwas  move.b        d1,d0
        and.b         #8,d0
        beq.s         nixabort
        move.l        (a7)+,d0      ; ESC-Taste gedrckt
        bsr           sound
        bra           abortgame
nixabort
        move.b        d1,d0
        and.b         #64,d0
        beq.s         nixgiveup
        move.l        (a7)+,d0      ; SPACE/Feuer-Taste gedrckt
        bsr           sound
        bra           lostlife
nixgiveup
        lea           which_werner(pc),a0 ; Bewegungsrichtung dekodieren
        move.b        (a0),d2
        move.b        d1,d0
        move.b        #0,d3
        move.b        #0,d4
        and.b         #2,d0
        beq.s         noleft
        move.b        #-1,d3
        move.b        #2,d2
        bra.s         fort
noleft  move.b        d1,d0
        and.b         #16,d0
        beq.s         noright
        move.b        #1,d3
        move.b        d3,d2
        bra.s         fort
noright move.b        d1,d0
        and.b         #4,d0
        beq.s         noup
        move.b        #-1,d4
        bra.s         fort
noup    move.b        #1,d4
fort    lea           werner_x(pc),a1
        add.b         (a1)+,d3
        add.b         (a1)+,d4
        bsr           calc
        cmp.b         #0,d0         ; Test ob neue Position fr Bewegung erlaubt
        beq.s         moveto
        cmp.b         #6,d0
        beq.s         moveto
        cmp.b         #3,d0         ; auf Polizisten gelaufen
        beq.s         futsch
        cmp.b         #4,d0
        beq.s         futsch
        cmp.b         #7,d0         ; Bierfalsche eingesammelt
        beq.s         geschafft
        cmp.b         #9,d0         ; Bierkasten eingesammelt
        beq.s         special
        cmp.b         (a1),d2
        beq.s         noturn
        move.b        d2,(a2)       ; Figur nur umdrehen, nicht bewegen
        move.b        d2,d5
        move.b        d2,(a1)
        move.b        -(a1),d6
        move.b        -(a1),d7
        bra           showsprite
noturn  rts

special bsr           moveto
        lea           score(pc),a0
        move.l        #$5000,d7
        bsr           bcderh
        bra           showscore
geschafft
        bsr           moveto
        lea           numbier(pc),a4
        sub.b         #1,(a4)
        bne.s         takemore
        move.l        (a7)+,d0
        bra           levelcompl
takemore
        lea           score(pc),a0
        move.l        #$1000,d7
        bsr           bcderh
        bra           showscore
futsch  bsr           moveto
        move.l        (a7)+,d0
        bra           lostlife

; Routine fr Fortbewegen von Sprites
moveto  move.b        d2,(a0)
        lea           werner_x(pc),a1
        move.w        (a1),d0
        move.b        (a1),d7
        move.b        d3,(a1)+
        move.b        (a1),d6
        move.b        d4,(a1)+
        move.b        d2,(a1)
        move.b        #0,d5
        bsr           showsprite    ; alte Position lschen
        move.b        d3,d7
        move.b        d4,d6
        move.b        d2,d5
        bsr           showsprite    ; an der neuen Position aufbauen
        move.b        d0,d4
        lsr.w         #8,d0
        move.b        d0,d3
        bsr           calc
        move.b        #0,(a0)
        lea           knupar(pc),a3
        move.b        #$11,d0
        trap          #1            ; Schrittgerusch vom IPC
        rts

; Umrechung Koordinaten -> Adresse
calc    lea           nowlevel(pc),a0         ;
        move.b        d3,-(a7)      ;werner position
        move.b        d4,-(a7)      ;auf stapel
        and.w         #127,d3
        and.w         #127,d4
        mulu          #20,d4        ;adresse
        add.l         d4,a0         ;wird
        add.l         d3,a0         ;berechnet
        move.b        (a0),d0
        move.b        (a7)+,d4
        move.b        (a7)+,d3
        rts

; Steuerroutine fr Polizisten
bullen  lea           counter(pc),a0 ; nur jedes 2. mal behandeln
        move.b        (a0),d0
        add.b         #1,d0
        move.b        d0,(a0)
        and.b         #1,d0
        beq.s         einpol
        rts
einpol  lea           anz_bull(pc),a6
        sub.w         d1,d1
        move.b        (a6)+,d1
        cmp.b         #0,d1         ; gibt es welche?
        bne.s         aktiv
        rts
aktiv   sub.b         #1,d1         ; ja!
nextb   move.b        (a6),d3
        cmp.b         #255,d3       ; Bulle schon vernichtet?
        beq.s         nextbulle
        move.b        1(a6),d4
        bsr           calc
        move.l        a0,a2
        cmp.b         #3,d0         ; Bulle von einem Stein getroffen?
        beq.s         existing
        cmp.b         #4,d0
        beq.s         existing
        move.b        #255,(a6)
nextbulle
        add.l         #4,a6
        dbra          d1,nextb
        rts
existing
        move.b        d0,d7         ; orthogonale Richtungen testen
        move.b        2(a6),d2
        bsr           possible
        add.b         #1,d2
        bsr           possible
        sub.b         #1,d2
        bsr           possible
        add.b         #2,d2         ; gehts nur wieder zurck?
        bsr           possible
        bra.s         nextbulle

possible
        and.b         #3,d2         ; Bewegungsrichtung dekodieren
        move.b        d7,d5
        move.b        (a6),d3
        move.b        1(a6),d4
        cmp.b         #0,d2
        bne.s         xr
        add.b         #1,d3
        move.b        #3,d5
        bra.s         xcon
xr      cmp.b         #1,d2
        bne.s         xu
        sub.b         #1,d4
        bra.s         xcon
xu      cmp.b         #2,d2
        bne.s         xl
        sub.b         #1,d3
        move.b        #4,d5
        bra.s         xcon
xl      add.b         #1,d4
xcon    bsr           calc
        cmp.b         #0,d0
        beq.s         gehhin
        cmp.b         #1,d0
        beq.s         gehhin
        cmp.b         #2,d0
        beq.s         gehhin
        cmp.b         #13,d0
        beq.s         gehhin
        move.b        2(a6),d2
        rts
gehhin  move.l        (a7)+,d0      ; Polizist bewegen
        move.b        d3,(a6)
        move.b        d4,1(a6)
        move.b        d2,2(a6)
        move.b        #0,(a2)
        move.b        d5,(a0)
        move.l        a0,a1
        bsr           whatpos
        move.l        a2,a1
        move.b        #0,d5
        bsr           whatpos
        bra           nextbulle

; Steuerroutine fr das Fallen der Steine
steine  lea           quiet(pc),a0
        move.b        #0,(a0)
        lea           nowede(pc),a0 ; ab da ist Fall mglich
        move.w        #197,d0
ssss    move.b        -(a0),d1
        move.b        #0,d2
        cmp.b         #5,d1
        beq.s         bewegen
        move.b        #1,d2
        cmp.b         #128+5,d1     ; ein schon fallender Stein fllt weiter?
        beq.s         bewegen
sweiter dbra          d0,ssss
        rts
bewegen move.b        20(a0),d1     ; kann Stein nach unten fallen?
        cmp.b         #0,d1
        beq           falldown
        cmp.b         #1,d2
        bne.s         nixbeweg
        cmp.b         #4,d1
        bgt.s         nixbeweg
        cmp.b         #0,d1
        bgt           falldown
nixbeweg
        and.b         #127,d1
        cmp.b         #5,d1
        bne           noausnahm

sidefall
        move.b        21(a0),d1     ; Nach rechts runterfallen?
        move.b        1(a0),d3      ; ist rechts neben ganz frei?
        cmp.b         #0,d1
        bne.s         nixright
        cmp.b         #0,d3
        beq           fallright
nixright
        cmp.b         #1,d2
        bne.s         noexept
        cmp.b         #4,d1
        bgt.s         noexept
        cmp.b         #1,d1
        blt.s         noexept
        cmp.b         #0,d3
        beq.s         fallright
noexept move.b        19(a0),d1     ; nach links runterfallen?
        move.l        a0,a4
        sub.l         #1,a4
        move.b        (a4),d3
        cmp.b         #0,d1
        bne.s         nol
        cmp.b         #0,d3
        beq.s         falleft
nol     cmp.b         #1,d2
        bne.s         noausnahm
        cmp.b         #4,d1
        bgt.s         noausnahm
        cmp.b         #1,d1
        blt.s         noausnahm
        cmp.b         #0,d3
        beq.s         falleft
noausnahm
        move.b        #5,(a0)
        bra           sweiter

falldown
        move.l        a0,a2         ; Stein runterfallen lassen
        add.l         #20,a2
        bsr           movestone
        bra           sweiter

fallright
        move.l        a0,a2         ; Stein runterrutschen lassen
        add.l         #1,a2
        bsr           movestone
        bra           sweiter
falleft move.l        a0,a2
        sub.l         #1,a2
        bsr           movestone
        sub.l         #1,a0
        bra           sweiter

movestone
        lea           quiet(pc),a1  ; es wurde mind. 1 Stein bewegt
        move.b        #$ff,(a1)
        move.b        #9,d5
        move.b        d5,(a2)
        cmp.b         #3,d1
        beq.s         einb
        cmp.b         #4,d1
        beq.s         einb
        move.b        #5,d5
        move.b        #128+5,(a2)   ; als fallend in BIT 7 markieren
einb    move.b        #0,(a0)
        move.l        a2,a1
        bsr           whatpos
        move.l        a0,a1
        move.b        #0,d5

; Umrechnung Adresse -> Koordinate
whatpos lea           nowlevel(pc),a3
        sub.l         a3,a1
        move.l        a1,d6
        divu          #20,d6
        swap          d6
        move.b        d6,d7
        swap          d6
        bra           showsprite    ; und gleich anzeigen

; Steuerroutine fr Dekrementieren des Bonus
dobonus lea           bonus(pc),a0
        cmp.l         #0,(a0)
        beq.s         bunten
        move.l        #$99999990,d7 ; entspricht 10 abziehen
        bsr           bcderh
bunten  bsr           showbonus
        move.w        #$fff,d0
wbon    dbra          d0,wbon
        rts

; Diese Routine wartet, bis alle Steine wieder in Ruhe sind
findschl
        lea           werner_x(pc),a0
        move.b        (a0)+,d3
        move.b        (a0),d4
        bsr           calc
        add.b         #128,(a0)
fsch    bsr           animation     ; solange alles weiterlaufen lassen
        bsr           bullen
        bsr           steine
        lea           quiet(pc),a0  ; alles ruhig?
        cmp.b         #0,(a0)
        beq.s         kalle
        move.w        #$1200,d0
qwert   dbra          d0,qwert
        bra.s         fsch
kalle   rts

; Steuerung der Animation der Werner-Sprites
animation
        lea           anif(pc),a1   ;diese routine
        move.b        (a1),d0       ;bewirkt
        add.b         #1,d0         ;das die nchste
        move.b        d0,(a1)+      ;nur
        and.b         #1,d0         ;jedes
        beq.s         do_ani        ;2. mal augefhrt wird
        rts
do_ani  lea           werner_x(pc),a2         ;werner
        move.b        (a2),d3       ;startposition
        move.b        1(a2),d4      ;laden
        bsr           calc          ;daraus adresse berechnen
        and.b         #127,d0
        cmp.b         #1,d0
        beq.s         anx
        cmp.b         #2,d0
        beq.s         anx
        rts
anx     move.b        (a1),d1
        add.b         #1,(a1)       ; nchste Bewegungsnummer
        and.b         #3,(a1)
        move.b        #13,d5
        cmp.b         #3,d1
        beq.s         lbl
        cmp.b         #1,d1
        beq.s         lbl
        move.b        #15,d5
        cmp.b         #2,d1
        beq.s         lbl
        sub.b         d5,d5
lbl     add.b         d0,d5
        move.b        (a2)+,d7
        move.b        (a2),d6
        bra           showsprite    ; Werner neu anzeigen

insert  lea           werner_x(pc),a1 ; Werner tot -> Werner umverwundbar
        move.b        (a1),d3
        move.b        1(a1),d4
        bsr           calc
        move.b        #12,(a0)      ; Werner zur Mauer machen
        move.b        (a1)+,d7
        move.b        (a1),d6
        bsr           showsprite
        move.w        #15,d0        ; noch ein weilchen weiterbewegen
intloop move.w        d0,-(a7)
        bsr           bullen
        bsr           steine
        bsr           steine
        move.w        #$1200,d0
ddd     dbra          d0,ddd
        move.w        (a7)+,d0
        dbra          d0,intloop
        rts

kill_me moveq         #5,d0         ;kill
        moveq         #-1,d1        ;this job
        moveq         #0,d3         ;no errors
        trap          #1

; Piepston bei Tastendruck ausgeben
sound   lea           soundpar(pc),a3         ;IPC befehl laden
        move.b        #$11,d0       ;und
        trap          #1            ;ausfhren
        rts
soundpar
        dc.b          $a,$10,$44,$44,$aa,$66
        dc.b          50,20,50,20,0,0,0,5,0,0,0,0,0,0,0,0,1,0
knupar  dc.b          $a,$10,$44,$44,$aa,$66
        dc.b          50,20,50,20,0,0,0,1,0,0,0,0,15,0,0,0,1,0

; Variablensektion I
counter dc.b          0
quiet   dc.b          0
level   dc.b          0
lives   dc.b          0
score   dc.w          0,0
hiscore dc.w          0,0
bonus   dc.w          0,0

; Daten- und Variablensektion II
kanal1  dc.w          14
        dc.b          'CON_512X16A0X0'
scrollscr
        dc.w          20
        dc.b          'CON_358X16A74X240_10'
k1id    dc.w          0,0
k2id    dc.w          0,0
scrollid
        dc.w          0,0
premium dc.w          0,0
erstlev dc.b          0
maxlev  dc.b          19
copystart
        dc.b          '   (C) 1987  KARL SCHFER'
copyend
menustart
        dc.b          10,10,10,10,10,10,10,10
        dc.b          '        <ESC> AUFHREN',10
        dc.b          '        <F1>  SPIELSTART',10
        dc.b          '        <F2>  ANLEITUNG'
menuend
; Text der Statuszeile
titlest dc.b          '** SCORE 00000000 **  '
        dc.b          '** HISCORE 00000000 **  '
        dc.b          '>> BONUS 00000000 <<  '
        dc.b          '+ LIVES XXXXX +'
titlend
firstart
        dc.b          'Level : '
firend
; Der Anleitungstext
uberstart
        dc.b        '* * * * * W E R N E R * * * * *'
uberend
reststart
        dc.b        10,' MOIN, JUNGS UND MDELS!!!',10,10
        dc.b        '          Bin WERNER, weiss ja jeder!',10
leerstart
        dc.b        '          Hab Hobby:',10,10
        dc.b        '          Flasch',39,'BIER saufen.',10,10
        dc.b        '  Was DU soll',39,'s?!? Bring mich zum Bier.',10
        dc.b        '  Ist doch leicht, oder?  Sacht WERNER.',10,10,10
        dc.b        '  Naja, BULLEN gibt',39,'s auch. Bin',10
        dc.b        '  Moderrad gefahn. Ohne Lappen!',10,10
        dc.b        '  Gib Obacht auf STEINE. Fallen runter!',10
        dc.b        ' Was sonst? Und GITTER sind da.  Und nur',10
        dc.b        '    Bullen tun die weg.  Gibt',39,'s nich?',10,10
        dc.b        ' Also auf! Und nach',39,'m geschafften Level?',10,10
        dc.b        '        Noch einer! Aber hallo...'
restend
             
; Variablensektion III (Felder fr Sprites, Levels etc.)

bieranz DC.B     2,3,3,2,2,1,4,2,2,2,1,3,2,3,1,3,3,2,3,1
        DCB.B    200,0
numbier DC.W     0
anif    DC.W     0
werner_x
        DC.B     0
werner_y
        DC.B     0
which_werner
        DC.B     0
anz_bull
        DC.B     0
bulldata
        DCB.B    32,0
nowlevel
        DCB.B    219,0
nowede  DCB.B    41,0

        dc.b     'Spritedaten  :'
spritedata
        dcb.b     1944,0
        dc.b     'Einschaltbild  :'
hiresbild
        dcb.b    8704,0
        dc.b     'Leveldaten :'
leveldata
        dcb.b     7400,0
